// gpu/ipc/common/vulkan_info.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef GPU_IPC_COMMON_VULKAN_INFO_MOJOM_BLINK_H_
#define GPU_IPC_COMMON_VULKAN_INFO_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "gpu/ipc/common/vulkan_info.mojom-shared.h"
#include "gpu/ipc/common/vulkan_info.mojom-blink-forward.h"
#include "gpu/ipc/common/vulkan_types.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"







// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace gpu {
namespace mojom {
namespace blink {









class  VulkanPhysicalDeviceInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<VulkanPhysicalDeviceInfo, T>::value>;
  using DataView = VulkanPhysicalDeviceInfoDataView;
  using Data_ = internal::VulkanPhysicalDeviceInfo_Data;

  template <typename... Args>
  static VulkanPhysicalDeviceInfoPtr New(Args&&... args) {
    return VulkanPhysicalDeviceInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static VulkanPhysicalDeviceInfoPtr From(const U& u) {
    return mojo::TypeConverter<VulkanPhysicalDeviceInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VulkanPhysicalDeviceInfo>::Convert(*this);
  }


  VulkanPhysicalDeviceInfo();

  VulkanPhysicalDeviceInfo(
      ::gpu::mojom::blink::VkPhysicalDevicePropertiesPtr properties,
      WTF::Vector<::gpu::mojom::blink::VkExtensionPropertiesPtr> extensions,
      ::gpu::mojom::blink::VkPhysicalDeviceFeaturesPtr features,
      bool feature_sampler_ycbcr_conversion,
      bool feature_protected_memory,
      WTF::Vector<::gpu::mojom::blink::VkQueueFamilyPropertiesPtr> queue_families);

  ~VulkanPhysicalDeviceInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VulkanPhysicalDeviceInfoPtr>
  VulkanPhysicalDeviceInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VulkanPhysicalDeviceInfo::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VulkanPhysicalDeviceInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VulkanPhysicalDeviceInfo_UnserializedMessageContext<
            UserType, VulkanPhysicalDeviceInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VulkanPhysicalDeviceInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return VulkanPhysicalDeviceInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VulkanPhysicalDeviceInfo_UnserializedMessageContext<
            UserType, VulkanPhysicalDeviceInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VulkanPhysicalDeviceInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::gpu::mojom::blink::VkPhysicalDevicePropertiesPtr properties;
  
  WTF::Vector<::gpu::mojom::blink::VkExtensionPropertiesPtr> extensions;
  
  ::gpu::mojom::blink::VkPhysicalDeviceFeaturesPtr features;
  
  bool feature_sampler_ycbcr_conversion;
  
  bool feature_protected_memory;
  
  WTF::Vector<::gpu::mojom::blink::VkQueueFamilyPropertiesPtr> queue_families;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VulkanPhysicalDeviceInfo);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  VulkanInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<VulkanInfo, T>::value>;
  using DataView = VulkanInfoDataView;
  using Data_ = internal::VulkanInfo_Data;

  template <typename... Args>
  static VulkanInfoPtr New(Args&&... args) {
    return VulkanInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static VulkanInfoPtr From(const U& u) {
    return mojo::TypeConverter<VulkanInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VulkanInfo>::Convert(*this);
  }


  VulkanInfo();

  VulkanInfo(
      uint32_t api_version,
      uint32_t used_api_version,
      WTF::Vector<::gpu::mojom::blink::VkExtensionPropertiesPtr> instance_extensions,
      WTF::Vector<WTF::String> enabled_instance_extensions,
      WTF::Vector<::gpu::mojom::blink::VkLayerPropertiesPtr> instance_layers,
      WTF::Vector<VulkanPhysicalDeviceInfoPtr> physical_devices);

  ~VulkanInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VulkanInfoPtr>
  VulkanInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, VulkanInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VulkanInfo::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VulkanInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VulkanInfo_UnserializedMessageContext<
            UserType, VulkanInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VulkanInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return VulkanInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VulkanInfo_UnserializedMessageContext<
            UserType, VulkanInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VulkanInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint32_t api_version;
  
  uint32_t used_api_version;
  
  WTF::Vector<::gpu::mojom::blink::VkExtensionPropertiesPtr> instance_extensions;
  
  WTF::Vector<WTF::String> enabled_instance_extensions;
  
  WTF::Vector<::gpu::mojom::blink::VkLayerPropertiesPtr> instance_layers;
  
  WTF::Vector<VulkanPhysicalDeviceInfoPtr> physical_devices;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VulkanInfo);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, VulkanInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, VulkanInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, VulkanInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, VulkanInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
VulkanPhysicalDeviceInfoPtr VulkanPhysicalDeviceInfo::Clone() const {
  return New(
      mojo::Clone(properties),
      mojo::Clone(extensions),
      mojo::Clone(features),
      mojo::Clone(feature_sampler_ycbcr_conversion),
      mojo::Clone(feature_protected_memory),
      mojo::Clone(queue_families)
  );
}

template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>*>
bool VulkanPhysicalDeviceInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->properties, other_struct.properties))
    return false;
  if (!mojo::Equals(this->extensions, other_struct.extensions))
    return false;
  if (!mojo::Equals(this->features, other_struct.features))
    return false;
  if (!mojo::Equals(this->feature_sampler_ycbcr_conversion, other_struct.feature_sampler_ycbcr_conversion))
    return false;
  if (!mojo::Equals(this->feature_protected_memory, other_struct.feature_protected_memory))
    return false;
  if (!mojo::Equals(this->queue_families, other_struct.queue_families))
    return false;
  return true;
}

template <typename T, VulkanPhysicalDeviceInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.properties, rhs.properties))
    return true;
  if (std::less<>{}(rhs.properties, lhs.properties))
    return false;
  if (std::less<>{}(lhs.extensions, rhs.extensions))
    return true;
  if (std::less<>{}(rhs.extensions, lhs.extensions))
    return false;
  if (std::less<>{}(lhs.features, rhs.features))
    return true;
  if (std::less<>{}(rhs.features, lhs.features))
    return false;
  if (std::less<>{}(lhs.feature_sampler_ycbcr_conversion, rhs.feature_sampler_ycbcr_conversion))
    return true;
  if (std::less<>{}(rhs.feature_sampler_ycbcr_conversion, lhs.feature_sampler_ycbcr_conversion))
    return false;
  if (std::less<>{}(lhs.feature_protected_memory, rhs.feature_protected_memory))
    return true;
  if (std::less<>{}(rhs.feature_protected_memory, lhs.feature_protected_memory))
    return false;
  if (std::less<>{}(lhs.queue_families, rhs.queue_families))
    return true;
  if (std::less<>{}(rhs.queue_families, lhs.queue_families))
    return false;
  return false;
}
template <typename StructPtrType>
VulkanInfoPtr VulkanInfo::Clone() const {
  return New(
      mojo::Clone(api_version),
      mojo::Clone(used_api_version),
      mojo::Clone(instance_extensions),
      mojo::Clone(enabled_instance_extensions),
      mojo::Clone(instance_layers),
      mojo::Clone(physical_devices)
  );
}

template <typename T, VulkanInfo::EnableIfSame<T>*>
bool VulkanInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->api_version, other_struct.api_version))
    return false;
  if (!mojo::Equals(this->used_api_version, other_struct.used_api_version))
    return false;
  if (!mojo::Equals(this->instance_extensions, other_struct.instance_extensions))
    return false;
  if (!mojo::Equals(this->enabled_instance_extensions, other_struct.enabled_instance_extensions))
    return false;
  if (!mojo::Equals(this->instance_layers, other_struct.instance_layers))
    return false;
  if (!mojo::Equals(this->physical_devices, other_struct.physical_devices))
    return false;
  return true;
}

template <typename T, VulkanInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.api_version, rhs.api_version))
    return true;
  if (std::less<>{}(rhs.api_version, lhs.api_version))
    return false;
  if (std::less<>{}(lhs.used_api_version, rhs.used_api_version))
    return true;
  if (std::less<>{}(rhs.used_api_version, lhs.used_api_version))
    return false;
  if (std::less<>{}(lhs.instance_extensions, rhs.instance_extensions))
    return true;
  if (std::less<>{}(rhs.instance_extensions, lhs.instance_extensions))
    return false;
  if (std::less<>{}(lhs.enabled_instance_extensions, rhs.enabled_instance_extensions))
    return true;
  if (std::less<>{}(rhs.enabled_instance_extensions, lhs.enabled_instance_extensions))
    return false;
  if (std::less<>{}(lhs.instance_layers, rhs.instance_layers))
    return true;
  if (std::less<>{}(rhs.instance_layers, lhs.instance_layers))
    return false;
  if (std::less<>{}(lhs.physical_devices, rhs.physical_devices))
    return true;
  if (std::less<>{}(rhs.physical_devices, lhs.physical_devices))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace gpu

namespace mojo {


template <>
struct  StructTraits<::gpu::mojom::blink::VulkanPhysicalDeviceInfo::DataView,
                                         ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr> {
  static bool IsNull(const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) { return !input; }
  static void SetToNull(::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr* output) { output->reset(); }

  static const decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::properties)& properties(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->properties;
  }

  static const decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::extensions)& extensions(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->extensions;
  }

  static const decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::features)& features(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->features;
  }

  static decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::feature_sampler_ycbcr_conversion) feature_sampler_ycbcr_conversion(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->feature_sampler_ycbcr_conversion;
  }

  static decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::feature_protected_memory) feature_protected_memory(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->feature_protected_memory;
  }

  static const decltype(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::queue_families)& queue_families(
      const ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr& input) {
    return input->queue_families;
  }

  static bool Read(::gpu::mojom::blink::VulkanPhysicalDeviceInfo::DataView input, ::gpu::mojom::blink::VulkanPhysicalDeviceInfoPtr* output);
};


template <>
struct  StructTraits<::gpu::mojom::blink::VulkanInfo::DataView,
                                         ::gpu::mojom::blink::VulkanInfoPtr> {
  static bool IsNull(const ::gpu::mojom::blink::VulkanInfoPtr& input) { return !input; }
  static void SetToNull(::gpu::mojom::blink::VulkanInfoPtr* output) { output->reset(); }

  static decltype(::gpu::mojom::blink::VulkanInfo::api_version) api_version(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->api_version;
  }

  static decltype(::gpu::mojom::blink::VulkanInfo::used_api_version) used_api_version(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->used_api_version;
  }

  static const decltype(::gpu::mojom::blink::VulkanInfo::instance_extensions)& instance_extensions(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->instance_extensions;
  }

  static const decltype(::gpu::mojom::blink::VulkanInfo::enabled_instance_extensions)& enabled_instance_extensions(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->enabled_instance_extensions;
  }

  static const decltype(::gpu::mojom::blink::VulkanInfo::instance_layers)& instance_layers(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->instance_layers;
  }

  static const decltype(::gpu::mojom::blink::VulkanInfo::physical_devices)& physical_devices(
      const ::gpu::mojom::blink::VulkanInfoPtr& input) {
    return input->physical_devices;
  }

  static bool Read(::gpu::mojom::blink::VulkanInfo::DataView input, ::gpu::mojom::blink::VulkanInfoPtr* output);
};

}  // namespace mojo

#endif  // GPU_IPC_COMMON_VULKAN_INFO_MOJOM_BLINK_H_